/*
 * StreamToTextArea.java
 *
 * Created on August 28, 2004, 11:21 AM
 */

import javax.swing.*;
import java.io.*;

/**
 *
 * @author  guardia
 */

class StreamToTextArea extends Thread
{
    private InputStream theInputStream;
    private JTextArea thejTextArea;
    private JLabel theErrorLabel;
    private Runnable theRunnable;
    /** Creates a new instance of StreamToTextArea */
    StreamToTextArea(InputStream inputStream, JTextArea jTextArea, JLabel errorLabel, Runnable runnable) {
        theInputStream = inputStream;
        thejTextArea = jTextArea;
        theErrorLabel = errorLabel;
        theRunnable = runnable;
    }
    
    public void run() {
        BufferedReader reader = new BufferedReader(new InputStreamReader(theInputStream));
        
        try {
            String line = null;
            while ( (line = reader.readLine()) != null) {
                thejTextArea.append(line);
                thejTextArea.append("\n");
                // scroll down...
                thejTextArea.setCaretPosition(thejTextArea.getDocument().getLength());
            }          
        }
        catch(IOException e) {
            theErrorLabel.setText(e.getMessage());
        }
        if(theRunnable != null)
            SwingUtilities.invokeLater(theRunnable);
    }
}
   